﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#StartCommandReturnValue: android.app.Service.START_STICKY
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'Dim eGPS As GPS
	Dim dGPS As LocationManagerEx 'GPS
	
	Dim Loca As LocationRequest
	Dim bState As Priority
	
	Public Stado As String=""
	Public Cfg As Map
	
	Dim GPXIni As String="<?xml version='1.0' encoding='UTF-8'?><gpx version='1.1' creator='Geolocalización Software 2018' xmlns='http://www.topografix.com/GPX/1/1' xmlns:xsi='http://www.w3.org/2001/XMLSchema-instance'><metadata><time>2018-01-22T18:52:34.965Z</time><bounds minlat='41.994729000' minlon='-1.790696000' maxlat='42.063240000' maxlon='-1.661721000'/></metadata><trk><name>Geolocalización</name><cmt/><trkseg>"
	Dim GPXPunto As String="<trkpt lat='latitud' lon='longitud'><time>fechaThoraZ</time></trkpt>"
	Dim GPXFin As String="</trkseg></trk></gpx>"

End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	Loca.Initialize
	Loca.SetPriority(bState.PRIORITY_HIGH_ACCURACY)

	dGPS.Initialize("dGPS")
	
	'eGPS.Initialize("eGPS")
	If File.Exists(File.DirDefaultExternal,"Config.ini") Then
		Cfg=File.ReadMap(File.DirDefaultExternal,"Config.ini")
	Else
		Cfg.Initialize
	End If
	Stado=Cfg.GetDefault("Stado","")
End Sub

Sub Service_Start (StartingIntent As Intent)
	Stado=Cfg.GetDefault("Stado","")
	If Stado<>"" Then
		'If eGPS.GPSEnabled = False Then
		'	ToastMessageShow("Please enable the GPS device.", True)
		'	StartActivity(eGPS.LocationSettingsIntent) 'Will open the relevant settings screen.
		'End If
		dGPS.requestGPSLocation
	End If
	
	Log(DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & " Start Service")
	End Sub

Sub Service_TaskRemoved
	Log(DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & " Service TaskRemoved")
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Log(DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & " Service Application Error")
	Return True
End Sub

Sub Service_Destroy
	Log(DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & " Service Destroy")
	CallSub(Main,"DesConectar")
	dGPS.stopGPSListening'.Stop
End Sub

Sub dGPS_LocationChanged(Location1 As Location)
	If Location1.Latitude=0 And Location1.Longitude=0 Then
		Log(DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & " Location Changhe NO LOCK")
		Return
	Else
		Log(DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & " Location Changhe LOCK")
	End If
	If Stado="" Then Return
	Try
		If Stado="bus" Then CallSub(Main,"Conectar")
	Catch
	End Try
	Dim Lst As List
	If File.Exists(File.DirDefaultExternal,"aRuta 2018.gpx") Then
		Lst=File.ReadList(File.DirDefaultExternal,"aRuta 2018.gpx")
	Else
		Lst.Initialize
		Lst.Add(GPXIni)
		Lst.Add(GPXFin)
	End If
	Lst.RemoveAt(Lst.Size-1)
	DateTime.DateFormat="yyyy-MM-dd"
	DateTime.TimeFormat="HH:mm:ss"
	Dim Punto As String
	Punto=GPXPunto.Replace("latitud",Location1.Latitude)
	Punto=Punto.Replace("longitud",Location1.Longitude)
	Punto=Punto.Replace("fecha",DateTime.Date(DateTime.Now))
	Punto=Punto.Replace("hora",DateTime.Time(DateTime.Now))
	Lst.Add(Punto)
	Lst.Add(GPXFin)
	File.Writelist(File.DirDefaultExternal,"aRuta 2018.gpx",Lst)
End Sub